<template>
  <two-panes>
    <template slot="left">
      <div class="table-header">
        <div class="table-caption">Роли участников</div>
      </div>
      <ob-table
        :items="roles"
        :columns="columns"
        :functional-panel="true"
        :table-layout-fixed="true"
        :is-functional-sort="false"
        :is-functional-group="false"
        :is-css-selectable="true"
        ref="rolesTable"
        @select="onSelect"
      >
        <div
          slot="roleTitle"
          slot-scope="{ data }"
          class="role-badge"
        >
          <i :class="[ 'icon role-badge__icon', iconByRoleV3(data.item.code) ]" />

          {{ data.item.title || '—' }}
        </div>
      </ob-table>
    </template>
    <template slot="right">
      <div class="table-header table-header__right">
        <ObTabs
          ref="contractor-roles-tabs"
          :items="tabs"
          :no-border="true"
          @on-change-tab="onChangeTab"
        />
      </div>
      <ob-table
        v-if="selectedTabId === 1"
        :columns="contractorsColumns"
        :items="contractorsItems"
        :is-functional-sort="false"
        :is-functional-group="false"
        :functional-panel="true"
        ref="contractorsTable"
      />
      <ob-table
        v-else
        :columns="accessColumns"
        :items="accessItems"
        :is-functional-sort="false"
        :is-functional-group="false"
        :functional-panel="true"
        ref="accessTable"
      />
    </template>
  </two-panes>
</template>

<script>
import moment   from 'moment';
import api      from '@/api';
import { iconByRoleV3 } from '@/helpers/user'

import TwoPanes from 'common-components/src/obComponents/obTwoPanels';
import ObTable  from 'common-components/src/obComponents/obTable';
import ObTabs from "common-components/src/obComponents/obTabs/index";

export default {
  name: 'ContractorRoles',
  components: {
    ObTable,
    ObTabs,
    TwoPanes
  },
  data() {
    return {
      roles: [],
      contractorsItems: [],
      accessItems: [],
      tabs: [
        {
          title: "Участники",
          name: "participants",
          id: 1
        },
        {
          title: "Доступы",
          name: "access",
          id: 2
        },
      ],
      selectedTabId: 1
    };
  },
  computed: {
    columns() {
      return [
        {
          title: 'Роль участника',
          key: 'title',
          sortOrder: 'asc',
          exactWidth: "162px",
          slotName: 'roleTitle'
        },
        {
          title: 'Количество участников',
          key: 'contractors_count',
          exactWidth: "141px",
          html: ({ contractors_count }) => String(contractors_count),
        },
        {
          title: 'Элементарных ролей',
          key: 'keycloak_count',
          exactWidth: "132px"
        }
      ];
    },
    contractorsColumns() {
      return [
        {
          title: 'Наименование участника',
          key: 'title',
          exactWidth: "284px"
        },
        {
          title: 'ИНН',
          width: 'auto',
          html: ({ inn }) => inn || ''
        },
        {
          title: 'КПП',
          width: 'auto',
          html: ({ kpp }) => kpp || ''
        },
        {
          title: 'Активных пользователй',
          width: 'auto',
          html: ({ users_count }) => users_count || ''
        },
        {
          title: 'Дата регистрации',
          width: 'auto',
          html: ({ created_at }) => moment(created_at).format('DD.MM.YYYY')
        },
        {
          title: 'Страна',
          html: ({ country_code }) => country_code ? country_code.toUpperCase() : '',
          width: 'auto'
        }
      ];
    },
    accessColumns() {
      return [
        {
          title: 'Элементарные роли',
          key: 'title'
        }
      ]
    }
  },
  async mounted() {
    this.roles = await this.getContractorRoles();
    this.$nextTick(() => {
      this.selectFirstRole();
    });
  },
  methods: {
    iconByRoleV3,
    selectFirstRole() {
      const firstRole = this.$refs['rolesTable'].currentItems[0];

      if (firstRole) {
        this.onSelect(firstRole.item);
        firstRole._isSelected = true;
      }
    },

    async onSelect(role) {
      const contractors = await api.contractors.getByRole(role.uuid);
      const access = await api.user_roles.getKeycloakRolesByContractor(role.uuid);
      this.contractorsItems = contractors?.data.contractors;
      this.accessItems = access?.keycloak_roles;
    },

    async getContractorRoles () {
      try {
        return await api.adminPanel.adminPanelRoles.getContractorRoles()
      }
      catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        });
      }
    },
    async onChangeTab({ id }) {
      this.selectedTabId = id;
    }
  }
};
</script>

<style lang="scss" scoped>
@import '~common-components/src/static/css/mixins';

.role-badge {
  @include font-mixin(14px, 18px, 400, $color-text-base);

  display: flex;
  align-items: center;

  &__icon {
    color: $blue-700;
    font-size: 16px;
    margin-right: 10px;
    position: relative;
    top: -1px; // To visually centering icon
  }
}

.table-header {
  height: 44px;
  flex: none;
  background: #fff;
  padding: 0 20px;
  display: flex;
  align-items: center;
  box-shadow: 0px 0px 2px rgba(0, 75, 200, 0.15), 0px 0px 12px rgba(0, 75, 200, 0.04), 0px 4px 10px rgba(0, 75, 200, 0.06);
  position: relative;
  z-index: 1;

  &__right {
    padding: 0 10px;
  }
}

.table-caption {
  font-weight: bold;
  font-size: 16px;
  line-height: 20px;
  letter-spacing: 0.4px;
  color: #191E32;
}

::v-deep {
  .ob_left_panel table {
    min-width: 435px;
  }

  .panel_header {
    height: 20px !important;
    padding: 0 !important;
  }
}

.right {
  z-index: 0;
  width: 20%;
  margin: 50px 20px 20px 0;
  min-width: 300px;
  display: flex;
  flex-grow: 1;
}
.table-container {
  display: flex;
  flex-direction: column;
  background: $background-white;
  box-shadow: 0 0 10px rgba($color-blue-navy-blue, 0.25);
}
.table-container span {
  position: absolute;
  @include font-mixin(12px, 16px, 700, $light-denim, 1.6px);
}
.resizer-parent::v-deep .table-container.left {
  z-index: 3;
}

@media (min-width: 701px) {
  .table-container span {
    margin: -30px 0 0 10px;
  }
  .left {
    width: 35%;
    min-width: 550px;
    max-width: 1000px;
    display: flex;
    margin: 50px 6px 20px 20px;
  }
  .back-icon {
    display: none;
  }
}

@media (max-width: 700px) {
  .table-container span {
    margin: -30px 0 0 10px;
  }
  .table-container span.inside {
    margin-left: 45px;
  }
  .back-icon {
    position: absolute;
    margin: -35px 0 0 15px;
  }
  .left {
    display: flex;
    margin: 50px 0 0 0;
  }
  .resizer-parent {
    visibility: hidden;
    position: absolute;
  }
  .table-container {
    visibility: visible;
    display: flex;
    flex-direction: column;
    width: 100%;
    min-width: 20%;
    margin: 50px 0 0 0;
    background: $background-white;
    box-shadow: 0 0 10px rgba($color-blue-navy-blue, 0.25);
  }

  .table-container.switch {
    display: none;
  }

  .table-container.multipane-resizer {
    display: none;
  }
}
</style>
